% Calculate Sorted error plots for SCO data
clc;
%clear all; 
close all;
%delete ./fig/*.eps;
set(0,'defaulttextfontsize',18);
symbols = {'@', 'A', 'C', 'D', 'E', 'G', 'I', 'J', 'O', 'R', 'S', 'T', 'U',...
    'W', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l',...
    'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'v', 'w', 'y', 'z'};
CONS = {'C','D','G','J','S','T','Z','b','d','f','g','h','k','l','m','n','p','r','s','t','v','w','y','z'};
VOWS = {'@','A','E','I','O','R','U','W','Y','a','c','e','i','o','u'};
READING_DISABLED = {'Alina','Angela','Edward','Latisha','Laura','Matt','Norene','Tina','Teddy','Tony'};

Nt = 2; % threshold for number of trails


addpath ./bin
%addpath ./bin
%Colors=setGrayColor; 

% get usbject names %Was dir('../*.mat')
d=dir('./data/*.mat');
mkdir data cons;


for sbj = 1 : length(d)
    mat_name = d(sbj).name;
    load(['./data/' mat_name]);
    SBJS{1,sbj} =  mat_name(6:length(mat_name)-4);
    
    error_cons = zeros(2,length(CONS));
    n_cons = zeros(2,length(CONS));
    error_vows = zeros(2,length(VOWS));
    n_vows = zeros(2,length(VOWS));
    zero_error_ci = zeros(length(CONS),1);
    for trial = 1 : length(data)
        if strcmp(data(trial).tgt1,'Q')
            data(trial).tgt1 = '@';
        end
        if strcmp(data(trial).tgt2,'Q')
            data(trial).tgt2 = '@';
        end
if strcmp(data(trial).msk1,'Q')
            data(trial).msk1 = '@';
        end
        if strcmp(data(trial).msk2,'Q')
            data(trial).msk2 = '@';
        end
        
        
        % Was first or second sound changed?
        if ~strcmp(data(trial).tgt1,data(trial).msk1)
            pos = 1; % inital was changed
            % VOW in inital position?
            vow_pos = find(strcmp(data(trial).tgt1,VOWS));
            con_pos = find(strcmp(data(trial).tgt1,CONS));
            if  ~isempty(vow_pos)
                if data(trial).score == 0
                    error_vows(pos,vow_pos) = error_vows(pos,vow_pos) + 1;
                end
                n_vows(pos,vow_pos) = n_vows(pos,vow_pos) + 1;
            elseif ~isempty(con_pos)
                con_pos = find(strcmp(data(trial).tgt1,CONS));
                if data(trial).score == 0
                    error_cons(pos,con_pos) = error_cons(pos,con_pos) + 1;
                end
                n_cons(pos,con_pos) = n_cons(pos,con_pos) + 1;
            else
                disp(['something is fishy with ' data(trial).tgt1 ' in initial position in trial ' num2str(trial)]);
            end
        elseif ~strcmp(data(trial).tgt2,data(trial).msk2)
            pos = 2; % final postion changed
            % VOW in final position?
            vow_pos = find(strcmp(data(trial).tgt2,VOWS));
            con_pos = find(strcmp(data(trial).tgt2,CONS));
            if  ~isempty(vow_pos)
                if data(trial).score == 0
                    error_vows(pos,vow_pos) = error_vows(pos,vow_pos) + 1;
                end
                n_vows(pos,vow_pos) = n_vows(pos,vow_pos) + 1;
            elseif ~isempty(con_pos)
                if data(trial).score == 0
                    error_cons(pos,con_pos) = error_cons(pos,con_pos) + 1;
                end
                n_cons(pos,con_pos) = n_cons(pos,con_pos) + 1;
            else
                disp(['something is fishy with ' data(trial).tgt2 ' in final position in trial ' num2str(trial)]);
            end
        else
            disp(['something is fishy ' num2str(trial)]);
        end
    end
    
    pe_cons = error_cons ./ n_cons;
    % TF = isnan(A) returns an array the same size as A containing logical 1 (true) 
    % where the elements of A are NaNs and logical 0 (false) where they are not. 
    % For a complex number z, 
    % isnan(z) returns 1 if either the real or imaginary part of z is NaN, 
    % and 0 if both the real and imaginary parts are finite or Inf.
    
    pe_cons(isnan(pe_cons)) = inf;
    [M V] = binostat(n_cons,pe_cons);
    pe_cons(3:4,:) = bsxfun(@gt, n_cons, Nt); % add flags for number of trails
    pe_cons(5:6,:) = V;
    pe_cons(7:8,:) = n_cons;
    
    
    pe_vows = error_vows ./ n_vows;
    pe_vows(isnan(pe_vows)) = inf;
    [M V] = binostat(n_vows,pe_vows(1:2,:));
    pe_vows(3:4,:) = bsxfun(@gt, n_vows, Nt); % great than Nt =2; All the f 
    pe_vows(5:6,:) = V;
    pe_vows(7:8,:) = n_vows;
    
    pe_allsbjs{1,sbj}=pe_vows;
    pe_allsbjs{2,sbj}=pe_cons;

    % modified by Benshuoshuo
    fileName = strjoin({'./data/cons/cons_', SBJS{1, sbj}, '.txt'}, '');
    fileID = fopen(fileName, 'w');
    fprintf(fileID,'%12s%12s%12s%12s%12s%12s%12s\n','symbols ','#err_c_ini','#n_c_ini','pe_ini','#err_c_fnl','#n_c_fnl','pe_fnl');

    for i = 1:length(CONS)
        fprintf(fileID, '%12s', CONS{i});
        fprintf(fileID, '%12.6f', error_cons(1, i));
        fprintf(fileID, '%12.6f', n_cons(1,i));
        fprintf(fileID, '%12.6f', pe_cons(1, i));
        fprintf(fileID, '%12.6f', error_cons(2, i));
        fprintf(fileID, '%12.6f', n_cons(2,i));
        fprintf(fileID, '%12.6f', pe_cons(2, i));
        fprintf(fileID, '\n');
    end
    fclose(fileID);
    
    % view the contents
    disp(SBJS{1, sbj});
    type(fileName);
    
    
end
